HDU 4821 String (HASH)

题意:给你一串字符串s,再给你两个数字m l,问你s中可以分出多少个长度为m*l的子串,并且子串分成m个长度为l的串每个都不完全相同

首先使用BKDRHash方法把每个长度为l的子串预处理成一个数字,接着根据题意直接map判重

BKDRHash:一种常用字符串hash,hash简单来说就是把一串字符串通过一些转化成为一个数字,并保证相同字符串转化的数字一样,不相同字符串转化的数字一定不一样。方法就是hash[i]=hash[i-1]*seed(进制)+str[i]-‘a‘+1(注意要加一,因为不能为0)

注意这儿unsigned long long可以自动取模,还有BKDRHash需要取进制31,131这些。

#include<set>
#include<map>
#include<queue>
#include<stack>
#include<cmath>
#include<vector>
#include<string>
#include<cstdio>
#include<cstring>
#include<stdlib.h>
#include<iostream>
#include<algorithm>
using namespace std;
#define eps 1E-8
/*注意可能会有输出-0.000*/
#define Sgn(x) (x<-eps? -1 :x<eps? 0:1)//x为两个浮点数差的比较,注意返回整型
#define Cvs(x) (x > 0.0 ? x+eps : x-eps)//浮点数转化
#define zero(x) (((x)>0?(x):-(x))<eps)//判断是否等于0
#define mul(a,b) (a<<b)
#define dir(a,b) (a>>b)
typedef long long ll;
typedef unsigned long long ull;
const int Inf=1<<28;
const double Pi=acos(-1.0);
const int Mod=1e9+7;
const int Max=100010;
const ull seed=31;//31 131 1313 ......
char str[Max];
ull hhash[Max],base[Max];//ull自动取模
map<ull,int> mp;//判重
void Init()//初始化seed倍数,用于hash删前一个字符
{
    base[0]=1ull;
    for(int i=1; i<Max; ++i)
        base[i]=base[i-1]*seed;
    return;
}
void Hash(int l,int len)//把每l个字符压缩成为一个数字
{
    for(int i=0; i<len; ++i)
    {
        if(i>=l)//首先删除前一个字符
            hhash[i]=hhash[i-1]-base[l-1]*(str[i-l]-‘a‘+1);
        else if(i)
            hhash[i]=hhash[i-1];
        else
            hhash[0]=0ull;
        hhash[i]=hhash[i]*seed+str[i]-‘a‘+1;//hash
        //printf("%llu\n",hhash[i]);
    }
    return ;
}
int Solve(int m,int l,int len)
{
    int ans=0,i;
    int now,sum;//记录当前运行到第几个 记录总共有多少种值
    Hash(l,len);//存下每l位map判重
    for(int i=l-1;i<l+l-1;++i)
    {
        now=sum=0;
        mp.clear();
        for(int j=i;j<len;j+=l)
        {
            now++;
            if(now>m)//删除前面超出区间的值
            {
                mp[hhash[j-m*l]]--;
             if(mp[hhash[j-m*l]]==0)
                sum--;
            }
            if(!mp.count(hhash[j])||mp[hhash[j]]==0)//此值在此子区间没有
            {
                mp[hhash[j]]=1;
                sum++;
            }
            else
                mp[hhash[j]]++;
            if(sum==m)
                ans++;
        }
    }
    return ans;
}
int main()
{
    int m,l;
    Init();//初始化
    while(~scanf("%d %d",&m,&l))
    {
        scanf("%s",str);
        printf("%d\n",Solve(m,l,strlen(str)));
    }
    return 0;
}
时间: 2024-10-06 00:32:14

HDU 4821 String (HASH)的相关文章

hdu 4821 String(字符串hash)

题目链接:hdu 4821 String 题意: 给你一个字符串,问你有多少子串,满足长度为m*len,并且这个子串能分成m个len长度的不同串. 题解: BKDRhash+map来判重.注意的是要以len长分类来扫,这样才不会超时. 1 #include<bits/stdc++.h> 2 #define F(i,a,b) for(int i=a;i<=b;++i) 3 using namespace std; 4 typedef unsigned long long ull; 5 co

HDU 4821 String 字符串hash(水

题意: 给定整数M L 一个字符串s 我们定义一个子串为"好"串 iff 1.长度为 M*L 2.把这个好串分成M段,每段长度为L,且每段各不相同. 且我们得到的这些好串不重复计算(即把这些好串去重) 问有几个好串 #include <stdio.h> #include <cstring> #include <iostream> #include <map> using namespace std; typedef unsigned lo

HDU 1425 sort (hash)

sort Time Limit: 6000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 29001    Accepted Submission(s): 8799 Problem Description 给你n个整数,请按从大到小的顺序输出其中前m大的数. Input 每组测试数据有两行,第一行有两个数n,m(0<n,m<1000000),第二行包含n个各不相同,

HDU - 1496 Equations (hash)

题意: 多组测试数据. 每组数据有一个方程 a*x1^2 + b*x2^2 + c*x3^2 + d*x4^2 = 0,方程中四个未知数 x1, x2, x3, x4 ∈ [-100, 100], 且都不为0. 给定a, b, c, d ∈ [-50, 50] ,且都不为0, 求上述条件下方程解的个数. 比赛的时候想到的是枚举三个,另一个可以直接算出来.但是一直TLE...结果就没做出来. 看了题解,用的hash,很巧妙.结果自己用map写还是T..最后用数组写的.     _φ(?_?? #i

HDU 4821 (hash)

这道题最重要的不仅是hash这种算法,更要学会利用好STL中的<map>才行. 将连续的L个字符经过hash赋值,最后线性判断.其中的判断步骤用到了map的插入特性. #include <iostream> #include <cstdio> #include <algorithm> #include <cstring> #include <map> using namespace std; #define maxn 500010 #

HDU - 3973 AC&#39;s String(Hash+线段树)

http://acm.hdu.edu.cn/showproblem.php?pid=3973 题意 给一个词典和一个主串.有两种操作,查询主串某个区间,问这主串区间中包含多少词典中的词语.修改主串某一位置的字符. 分析 题目要求区间查询,和单点更新,那么最先想到的应该是线段树.可字符串怎么利用线段树呢?用hash!首先将词典按规则hash后放入map,然后将主串的hash值放置入线段树中.问题来了,怎么更新结点的hash值呢?假如现在我们知道了s[l...mid]和s[mid+1...r]的ha

[BestCoder Round #3] hdu 4909 String (状压,计数)

String Problem Description You hava a non-empty string which consists of lowercase English letters and may contain at most one '?'. Let's choose non-empty substring G from S (it can be G = S). A substring of a string is a continuous subsequence of th

hdu 3336 Count the string(KMP)

一道应用kmp算法中next数组的题目 这其中vis[i]从1加到n vis[i]=[next[i]]+1; #include<string.h> #include<stdlib.h> #include<stdio.h> #include<iostream> #include<algorithm> using namespace std; char s[200005]; int b; int next[200005]; int vis[20000

hdu 4909 String (map + 状压)

题目大意: 给定一个可能含'?'的字符串.然后问这个字符串有多少个子串是含有所有的字符都只出现两次. 其中'?' 可以被替换成任意字符,也可以被remove... 思路分析: 这是bestcoder的round #3的第三题. 这道题的做法和 4908 的做法差不多. 我们把 '?' 左右两边的状态分别处理出来. 然后用map 计数.然后枚举左边的状态.同时枚举? 对应的字符. 然后去寻找右边对应的状态,此时 ans 就可以加上答案. 注意的是要考虑到以 ? 结尾的情况.所以在 ? 的状态要和上